"use client";
import {
  highlight_wrapper_default
} from "./chunk-HIH35QDK.mjs";

// src/highlight.tsx
import { findMatches, isArray, removeAccents } from "@nkey-ui/shared-utils";
import { Fragment, jsx } from "react/jsx-runtime";
function Highlight({ children, search, wrapper }) {
  const searchArray = isArray(search) ? search : [search];
  const searchStrings = searchArray.map((s) => typeof s === "string" ? s : s.text);
  const matches = findMatches(children, searchStrings);
  if (!matches || matches.length === 0) {
    return children;
  }
  return /* @__PURE__ */ jsx(Fragment, { children: matches.map(({ from, to, match }, i) => {
    const text = children.substring(from, to);
    const textSearch = searchArray.find(
      (s) => removeAccents(typeof s === "string" ? s : s.text).toLocaleLowerCase() === removeAccents(text).toLocaleLowerCase()
    );
    let CustomWrapper = wrapper;
    if (typeof textSearch === "object") {
      CustomWrapper = textSearch.wrapper;
    }
    return match ? /* @__PURE__ */ jsx(highlight_wrapper_default, { wrapper: CustomWrapper, children: text }, i) : text;
  }) });
}
Highlight.displayName = "NkeyUI.Highlight";
var highlight_default = Highlight;

export {
  Highlight,
  highlight_default
};
