"use client";
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Highlight: () => highlight_default,
  HighlightWrapper: () => highlight_wrapper_default
});
module.exports = __toCommonJS(src_exports);

// src/highlight.tsx
var import_shared_utils = require("@nkey-ui/shared-utils");

// src/highlight-wrapper.tsx
var import_theme = require("@nkey-ui/theme");
var import_jsx_runtime = require("react/jsx-runtime");
function HighlightWrapper({ children, wrapper: TextWrapper }) {
  return typeof TextWrapper === "function" ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(TextWrapper, { children }) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)("span", { className: (0, import_theme.highlightWrapper)({ color: TextWrapper }), children });
}
HighlightWrapper.displayName = "NkeyUI.HighlightWrapper";
var highlight_wrapper_default = HighlightWrapper;

// src/highlight.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
function Highlight({ children, search, wrapper }) {
  const searchArray = (0, import_shared_utils.isArray)(search) ? search : [search];
  const searchStrings = searchArray.map((s) => typeof s === "string" ? s : s.text);
  const matches = (0, import_shared_utils.findMatches)(children, searchStrings);
  if (!matches || matches.length === 0) {
    return children;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: matches.map(({ from, to, match }, i) => {
    const text = children.substring(from, to);
    const textSearch = searchArray.find(
      (s) => (0, import_shared_utils.removeAccents)(typeof s === "string" ? s : s.text).toLocaleLowerCase() === (0, import_shared_utils.removeAccents)(text).toLocaleLowerCase()
    );
    let CustomWrapper = wrapper;
    if (typeof textSearch === "object") {
      CustomWrapper = textSearch.wrapper;
    }
    return match ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(highlight_wrapper_default, { wrapper: CustomWrapper, children: text }, i) : text;
  }) });
}
Highlight.displayName = "NkeyUI.Highlight";
var highlight_default = Highlight;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Highlight,
  HighlightWrapper
});
